#!/usr/bin/env python

import sys
import pygtk
pygtk.require('2.0')

import gtk
import gtk.glade
import gnomeapplet
import gobject
import pynotify

from plugin_manager import PluginManager

gtk.gdk.threads_init()
root = '/home/x/Desktop/unknown/lollobox/notipy/'
gladefile = root+'dialogs.glade'
pluginsdir = root

def redirect_out(file):
    print 'redirect_out()'
    stdo = open(file+'.out', 'w', 0)
    stde = open(file+'.err', 'w', 0)
    sys.stderr = stde
    sys.stdout = stdo

redirect_out(root+'notipy')
print 'Starting notipy'

class Notipy(gnomeapplet.Applet):
    def update(self):
        print 'Notipy::update()'
        for name, instance in self.plugman.instances.items():
            data = filter(lambda l: len(l) == 3, instance.query())
            if len(data) == 0: return True
            data = data[-10:]
            data.reverse()
            for d in data:
                self.liststore.prepend(d)
            while len(self.liststore) > 10:
                del self.liststore[len(self.liststore)-1]

            n = pynotify.Notification(name, 'You have %i new message(s)' % len(data))
            n.show()
        return True
        
    def _toggle(self, widget, event):
        print 'Notipy::_toggle()'
        main = self.dialogs['main']
        if event.type == gtk.gdk.BUTTON_PRESS and event.button == 1:
            if main.get_property("visible"):
                main.hide()
            else:
                main.show_all()
        return False
        
    def _hide_main(self, event, data=None):
        print 'Notipy::_hide_main()'
        self.dialogs['main'].hide()
        return False

    def __init_gui__(self):
        print 'Notipy::__init_gui__()'
        self.dialogs = {}
        self.gladefile = gladefile
        self.wTree = gtk.glade.XML(self.gladefile) 
        self.dialogs['about'] = self.wTree.get_widget('about_dialog')
        self.dialogs['prefs'] = self.wTree.get_widget('prefs_dialog')
        self.dialogs['main'] = self.wTree.get_widget('main_window')
        self.main_box = self.wTree.get_widget('scroll_main')
        self.wTree.signal_autoconnect( {
            '_hide_main': self._hide_main
        })
        
        app_window = self.applet
        # Creates eventbox
        event_box = gtk.EventBox()
        event_box.set_events(gtk.gdk.BUTTON_PRESS_MASK)

	# Create label for temp
        temp = gtk.Label('Notipy')
        event_box.connect('button_press_event', self._toggle) 
        inside_applet = gtk.HBox()
        inside_applet.pack_start(temp)

        treeview = gtk.TreeView(self.liststore)

        # Just text rendering for the columns
        textrenderer = gtk.CellRendererText()

        # Add the column to the treeview
        column = gtk.TreeViewColumn('time', gtk.CellRendererText(), text=0)
        #column.set_sort_column_id(0)
        treeview.append_column(column)
        column = gtk.TreeViewColumn('level', gtk.CellRendererText(), text=1)
        #column.set_sort_column_id(1)
        treeview.append_column(column)
        column = gtk.TreeViewColumn('judger', gtk.CellRendererText(), text=2)
        #column.set_sort_column_id(2)
        treeview.append_column(column)

        self.main_box.add(treeview)
        self.main_box.show_all()

	# Adds hbox to eventbox
        event_box.add(inside_applet)
        app_window.add(event_box)
        app_window.show_all()
        return event_box
    
    def __init_notify__(self):
        print 'Notipy::__init_notify__()'
        if not pynotify.init("Basics"):
            sys.exit(1)
            
    def __init_plugins__(self):
        print 'Notipy::__init_plugins__()'
        self.plugman = PluginManager(pluginsdir)
        self.plugman.load()
        gobject.timeout_add (1000, self.update)

    def __init__(self, applet, iid):
        print 'Notipy::__init__()'
        self.__gobject_init__()	
        self.applet = applet
        self.liststore = gtk.ListStore(str, str, str)
        self.__init_gui__()
        self.__init_notify__()
        self.__init_plugins__()

def sample_factory(applet, iid):
    Notipy(applet, iid)
    return True

if len(sys.argv) == 2 and sys.argv[1] == "run-in-window":
    main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    main_window.set_title("notipy Applet")
    main_window.connect("destroy", gtk.main_quit) 
    applet = gnomeapplet.Applet()
    Notipy(applet, None)
    applet.reparent(main_window)
    main_window.show_all()
    gtk.main()
    sys.exit()

elif __name__ == '__main__':
    gnomeapplet.bonobo_factory("OAFIID:GNOME_NotipyApplet_Factory", 
        Notipy.__gtype__, 
        "hello",
        "0",
        sample_factory
    )

